local ADDON_NAME = ...
BetterExtraActionBarDB = BetterExtraActionBarDB or {}
local db

--masque shenanigans, may look terrible with background texture enabled! (the button border is part of the texture)
local MSQ = LibStub and LibStub("Masque", true)
if MSQ then
	--if Macaroon then return end --no bueno?
	MSQ:Group("BetterExtraActionButton"):AddButton(ExtraActionButton1)
end

--Don't manage the frame for me, thanks, and don't adjust other frames to account for it
UIPARENT_MANAGED_FRAME_POSITIONS["ExtraActionBarFrame"] = nil
for k, v in next, UIPARENT_MANAGED_FRAME_POSITIONS do
	v.extraActionBarFrame = nil
end

--decouple from MainMenuBar
ExtraActionBarFrame:SetParent(UIParent)
ExtraActionBarFrame.SetParent = function() end ---mine. fuck off.
ExtraActionBarFrame:SetMovable(true)
ExtraActionBarFrame:SetUserPlaced(false)

--the way i move the frame is pretty backward, yea, i know
local overlay = CreateFrame("Frame", nil, ExtraActionBarFrame)
overlay:SetPoint("TOP")
overlay:SetPoint("BOTTOM")

local frame = ExtraActionBarFrame
local unlocked = nil
local moving = nil

local function UpdateState()
	local artwork = frame.button.style

	--sigh.
	if InCombatLockdown() then
		artwork:SetAlpha(db.hidebg and 0 or 1)
		artwork:SetDesaturated(false)
		return
	end

	--use the full texture for clicks
	overlay:SetWidth(artwork:GetWidth())
	artwork:SetAlpha(1)

	if unlocked then
		--always show the art when unlocked
		artwork:SetAlpha(0.6)
		artwork:SetDesaturated(true)
		overlay:EnableMouseWheel(true)
	else
		artwork:SetDesaturated(false)
		overlay:EnableMouseWheel(false)
		if db.hidebg then
			--hide the art and make the clickable area just outside the button
			artwork:SetAlpha(0)
			overlay:SetWidth(64)
		end
	end
end

overlay:EnableMouse()
overlay:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and unlocked then
		frame:ClearAllPoints()
		frame:StartMoving()
		moving = true
	end
end)

overlay:SetScript("OnMouseUp", function(self, button)
	if button == "RightButton" then
		unlocked = not unlocked
		UpdateState()

	elseif button == "MiddleButton" then
		if unlocked then
			frame:SetScale(1)
			db.scale = nil
		end

	elseif moving then
		moving = nil
		frame:StopMovingOrSizing()
		frame:SetUserPlaced(false)

		local point, _, _, x, y = frame:GetPoint(1)
		db.point = point
		db.x = x
		db.y = y
	end
end)

overlay:SetScript("OnMouseWheel", function(self, delta)
	local scale = frame:GetScale() + (0.1 * delta)
	frame:SetScale(scale)
	db.scale = scale
end)

local function OnShow(self)
	--make sure we're skinned
	if MSQ then
		MSQ:Group("BetterExtraActionButton"):ReSkin()
	end

	--make sure the background is doing what it should be doing
	UpdateState()

	--avoid ACTION_BLOCKED messages since that shit spams bug grabber by default now
	if InCombatLockdown() then return end

	if db.point then
		frame:ClearAllPoints()
		frame:SetPoint(db.point, db.x, db.y)
	else --default placement?
		frame:ClearAllPoints()
		frame:SetPoint("BOTTOM", 0, 160)
	end

	if db.scale then
		frame:SetScale(db.scale)
	end
end
overlay:SetScript("OnShow", OnShow)

overlay:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" then
		if arg1 == ADDON_NAME then
			self:UnregisterEvent("ADDON_LOADED")
			--per char settings, could have just used SavedVariablesPerCharacter but meh
			local key = (UnitName("player")) .. " - " .. GetRealmName()
			if not BetterExtraActionBarDB[key] then
				BetterExtraActionBarDB[key] = {}
			end
			db = BetterExtraActionBarDB[key]
		else
			return
		end
	end

	--set up the frame and anchor it
	if frame:IsShown() then
		OnShow(self)
	elseif not InCombatLockdown() then
		frame:Show() --no idea why, but it seems to stop the shit popping into the upper left of your screen
		frame:Hide()
	end
end)
overlay:RegisterEvent("PLAYER_ENTERING_WORLD")
overlay:RegisterEvent("ADDON_LOADED")


SLASH_BETTEREXTRABUTTONBAR1 = "/beab"
SLASH_BETTEREXTRABUTTONBAR2 = "/eab"
SlashCmdList["BETTEREXTRABUTTONBAR"] = function(input)
	if input == "reset" then
		--reset position in case the frame is under the ui or offscreen
		if not InCombatLockdown() then
			wipe(db)
			frame:ClearAllPoints()
			frame:SetPoint("BOTTOM", 0, 160)
			print("Position reset.")
		else
			print("Unable to reset the button's position while in combat!")
		end

	elseif input == "toggle" then
		--show/hide the frame
		if not HasExtraActionBar() and not InCombatLockdown() then --don't mess with it if its up for a fight
			if frame:IsShown() then
				frame.intro:Stop()
				frame.outro:Play()
			else
				frame.button:Show()
				frame:Show()
				frame.outro:Stop()
				frame.intro:Play()
				if not frame.button.icon:GetTexture() then
					frame.button.icon:SetTexture("Interface\\ICONS\\ABILITY_SEAL") --Ability_Creature_Cursed_04
					frame.button.icon:Show()
				end
			end
		end

	elseif input == "togglebg" then
		--show/hide the fancy background texture
		db.hidebg = not db.hidebg
		UpdateState()

	else
		--should probably have soooooomething
		print("Usage: /beab [reset||toggle||togglebg]")
		print("Reset the button position or toggle showing the button or the button artwork")

	end
end
